commit 4f07e80ab7839b9ee75f4160b006e31bada72c61
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Wed Jan 24 15:50:40 2018 +0100

    Incremented the year in all according files to 2018.

diff --git a/Host/Source/SerialBoot/main.c b/Host/Source/SerialBoot/main.c
index 0370812..a41964d 100644
--- a/Host/Source/SerialBoot/main.c
+++ b/Host/Source/SerialBoot/main.c
@@ -215,7 +215,7 @@ static void DisplayProgramInfo(void)
   printf("Copyright (c) by Feaser  http://www.feaser.com                             \n");
   printf("---------------------------------------------------------------------------\n");
   printf("This tool was modified for the 'Autonomous Mini Robot' - AMiRo.            \n");
-  printf("Copyright (c) 2016..2017  Marvin Barther, Thomas Schoepping, and Stefan    \n");
+  printf("Copyright (c) 2016..2018  Marvin Barther, Thomas Schoepping, and Stefan    \n");
   printf("                          Herbrechtsmeier                                  \n");
   printf("This is free software; see the source for copying conditions. There is NO  \n");
   printf("warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.\n");
diff --git a/README.txt b/README.txt
index e295988..6c58dd4 100644
--- a/README.txt
+++ b/README.txt
@@ -2,7 +2,7 @@ AMiRo-BLT is the bootloader and flashing toolchain for the base version of the
 Autonomous Mini Robot (AMiRo) [1]. It is based on OpenBLT developed by Feaser
 (see <http://feaser.com/en/openblt.php>).
 
-Copyright (C) 2016..2017  Thomas Schöpping et al.
+Copyright (C) 2016..2018  Thomas Schöpping et al.
 (a complete list of all authors is given below)
 
 This program is free software: you can redistribute it and/or modify
diff --git a/Target/Makefile b/Target/Makefile
index 18ce28f..084801f 100644
--- a/Target/Makefile
+++ b/Target/Makefile
@@ -2,7 +2,7 @@
 # AMiRo-BLT is the bootloader and flashing toolchain for the base version of   #
 # the Autonomous Mini Robot (AMiRo). It is based on OpenBLT developed by       #
 # Feaser (see <http://feaser.com/en/openblt.php>).                             #
-# Copyright (C) 2016..2017  Thomas Schöpping et al.                            #
+# Copyright (C) 2016..2018  Thomas Schöpping et al.                            #
 #                                                                              #
 # This program is free software: you can redistribute it and/or modify         #
 # it under the terms of the GNU General Public License as published by         #
diff --git a/compiler/GCC/gccsetup.sh b/compiler/GCC/gccsetup.sh
index f32b677..b49e1f2 100755
--- a/compiler/GCC/gccsetup.sh
+++ b/compiler/GCC/gccsetup.sh
@@ -1,7 +1,7 @@
 ################################################################################
 # AMiRo-BLT is an bootloader and toolchain designed for the Autonomous Mini    #
 # Robot (AMiRo) platform.                                                      #
-# Copyright (C) 2016..2017  Thomas Schöpping et al.                            #
+# Copyright (C) 2016..2018  Thomas Schöpping et al.                            #
 #                                                                              #
 # This program is free software: you can redistribute it and/or modify         #
 # it under the terms of the GNU General Public License as published by         #
@@ -281,7 +281,7 @@ function printWelcomeText {
   printf "#                                                                    #\n"
   printf "######################################################################\n"
   printf "#                                                                    #\n"
-  printf "# Copyright (c) 2016..2017  Thomas Schöpping                         #\n"
+  printf "# Copyright (c) 2016..2018  Thomas Schöpping                         #\n"
   printf "#                                                                    #\n"
   printf "# This is free software; see the source for copying conditions.      #\n"
   printf "# There is NO warranty; not even for MERCHANTABILITY or FITNESS FOR  #\n"
diff --git a/compiler/compilersetup.sh b/compiler/compilersetup.sh
index 10d4b16..74459d4 100755
--- a/compiler/compilersetup.sh
+++ b/compiler/compilersetup.sh
@@ -1,7 +1,7 @@
 ################################################################################
 # AMiRo-BLT is an bootloader and toolchain designed for the Autonomous Mini    #
 # Robot (AMiRo) platform.                                                      #
-# Copyright (C) 2016..2017  Thomas Schöpping et al.                            #
+# Copyright (C) 2016..2018  Thomas Schöpping et al.                            #
 #                                                                              #
 # This program is free software: you can redistribute it and/or modify         #
 # it under the terms of the GNU General Public License as published by         #
@@ -281,7 +281,7 @@ function printWelcomeText {
   printf "#                                                                    #\n"
   printf "######################################################################\n"
   printf "#                                                                    #\n"
-  printf "# Copyright (c) 2016..2017  Thomas Schöpping                         #\n"
+  printf "# Copyright (c) 2016..2018  Thomas Schöpping                         #\n"
   printf "#                                                                    #\n"
   printf "# This is free software; see the source for copying conditions.      #\n"
   printf "# There is NO warranty; not even for MERCHANTABILITY or FITNESS FOR  #\n"
diff --git a/ide/QtCreator/QtCreatorSetup.sh b/ide/QtCreator/QtCreatorSetup.sh
index 7d83171..741fa86 100755
--- a/ide/QtCreator/QtCreatorSetup.sh
+++ b/ide/QtCreator/QtCreatorSetup.sh
@@ -1,7 +1,7 @@
 ################################################################################
 # AMiRo-BLT is an bootloader and toolchain designed for the Autonomous Mini    #
 # Robot (AMiRo) platform.                                                      #
-# Copyright (C) 2016..2017  Thomas Schöpping et al.                            #
+# Copyright (C) 2016..2018  Thomas Schöpping et al.                            #
 #                                                                              #
 # This program is free software: you can redistribute it and/or modify         #
 # it under the terms of the GNU General Public License as published by         #
@@ -281,7 +281,7 @@ function printWelcomeText {
   printf "#                                                                    #\n"
   printf "######################################################################\n"
   printf "#                                                                    #\n"
-  printf "# Copyright (c) 2016..2017  Thomas Schöpping                         #\n"
+  printf "# Copyright (c) 2016..2018  Thomas Schöpping                         #\n"
   printf "#                                                                    #\n"
   printf "# This is free software; see the source for copying conditions.      #\n"
   printf "# There is NO warranty; not even for MERCHANTABILITY or FITNESS FOR  #\n"
diff --git a/ide/idesetup.sh b/ide/idesetup.sh
index 8c407b5..faf861c 100755
--- a/ide/idesetup.sh
+++ b/ide/idesetup.sh
@@ -1,7 +1,7 @@
 ################################################################################
 # AMiRo-BLT is an bootloader and toolchain designed for the Autonomous Mini    #
 # Robot (AMiRo) platform.                                                      #
-# Copyright (C) 2016..2017  Thomas Schöpping et al.                            #
+# Copyright (C) 2016..2018  Thomas Schöpping et al.                            #
 #                                                                              #
 # This program is free software: you can redistribute it and/or modify         #
 # it under the terms of the GNU General Public License as published by         #
@@ -281,7 +281,7 @@ function printWelcomeText {
   printf "#                                                                    #\n"
   printf "######################################################################\n"
   printf "#                                                                    #\n"
-  printf "# Copyright (c) 2016..2017  Thomas Schöpping                         #\n"
+  printf "# Copyright (c) 2016..2018  Thomas Schöpping                         #\n"
   printf "#                                                                    #\n"
   printf "# This is free software; see the source for copying conditions.      #\n"
   printf "# There is NO warranty; not even for MERCHANTABILITY or FITNESS FOR  #\n"
diff --git a/setup.sh b/setup.sh
index 41cb021..ba56fb5 100755
--- a/setup.sh
+++ b/setup.sh
@@ -1,7 +1,7 @@
 ################################################################################
 # AMiRo-BLT is an bootloader and toolchain designed for the Autonomous Mini    #
 # Robot (AMiRo) platform.                                                      #
-# Copyright (C) 2016..2017  Thomas Schöpping et al.                            #
+# Copyright (C) 2016..2018  Thomas Schöpping et al.                            #
 #                                                                              #
 # This program is free software: you can redistribute it and/or modify         #
 # it under the terms of the GNU General Public License as published by         #
@@ -281,7 +281,7 @@ function printWelcomeText {
   printf "#                                                                    #\n"
   printf "######################################################################\n"
   printf "#                                                                    #\n"
-  printf "# Copyright (c) 2016..2017  Thomas Schöpping                         #\n"
+  printf "# Copyright (c) 2016..2018  Thomas Schöpping                         #\n"
   printf "#                                                                    #\n"
   printf "# This is free software; see the source for copying conditions.      #\n"
   printf "# There is NO warranty; not even for MERCHANTABILITY or FITNESS FOR  #\n"