commit f4b07d1ecd9cd23eeab5724d97a4f3aaf5f0eade
Author: Simon Schulz <sschulz@cit-ec.uni-bielefeld.de>
Date:   Wed Apr 15 13:21:19 2015 +0200

    fixed java

diff --git a/client/java/src/main/java/de/uni-bielefeld/cit-ec/opensource/hlrc/client/Emotions.java b/client/java/src/main/java/de/uni-bielefeld/cit-ec/opensource/hlrc/client/Emotions.java
index f102f6f..8851add 100644
--- a/client/java/src/main/java/de/uni-bielefeld/cit-ec/opensource/hlrc/client/Emotions.java
+++ b/client/java/src/main/java/de/uni-bielefeld/cit-ec/opensource/hlrc/client/Emotions.java
@@ -26,7 +26,7 @@
 *
 */
 
-package de.uni-bielefeld.cit-ec.opensource.hlrc.client;
+package de.uni_bielefeld.cit_ec.opensource.hlrc.client;
 
 public enum Emotions {
     NEUTRAL,
diff --git a/client/java/src/main/java/de/uni-bielefeld/cit-ec/opensource/hlrc/client/HeadAnimations.java b/client/java/src/main/java/de/uni-bielefeld/cit-ec/opensource/hlrc/client/HeadAnimations.java
index 9788b98..17c2314 100644
--- a/client/java/src/main/java/de/uni-bielefeld/cit-ec/opensource/hlrc/client/HeadAnimations.java
+++ b/client/java/src/main/java/de/uni-bielefeld/cit-ec/opensource/hlrc/client/HeadAnimations.java
@@ -26,7 +26,7 @@
 *
 */
 
-package de.uni-bielefeld.cit-ec.opensource.hlrc.client;
+package de.uni_bielefeld.cit_ec.opensource.hlrc.client;
 
 public enum HeadAnimations {
     IDLE,
diff --git a/client/java/src/main/java/de/uni-bielefeld/cit-ec/opensource/hlrc/client/MiddlewareRSB.java b/client/java/src/main/java/de/uni-bielefeld/cit-ec/opensource/hlrc/client/MiddlewareRSB.java
index 5dc2573..2f214a2 100644
--- a/client/java/src/main/java/de/uni-bielefeld/cit-ec/opensource/hlrc/client/MiddlewareRSB.java
+++ b/client/java/src/main/java/de/uni-bielefeld/cit-ec/opensource/hlrc/client/MiddlewareRSB.java
@@ -26,7 +26,7 @@
 *
 */
 
-package de.uni-bielefeld.cit-ec.opensource.hlrc.client;
+package de.uni_bielefeld.cit_ec.opensource.hlrc.client;
 
 import java.util.ArrayList;
 import java.util.HashMap;
diff --git a/client/java/src/main/java/de/uni-bielefeld/cit-ec/opensource/hlrc/client/RobotController.java b/client/java/src/main/java/de/uni-bielefeld/cit-ec/opensource/hlrc/client/RobotController.java
index 1479912..9106263 100644
--- a/client/java/src/main/java/de/uni-bielefeld/cit-ec/opensource/hlrc/client/RobotController.java
+++ b/client/java/src/main/java/de/uni-bielefeld/cit-ec/opensource/hlrc/client/RobotController.java
@@ -26,7 +26,7 @@
 *
 */
 
-package de.uni-bielefeld.cit-ec.opensource.hlrc.client;
+package de.uni_bielefeld.cit_ec.opensource.hlrc.client;
 
 import java.util.ArrayList;
 import java.util.concurrent.ExecutionException;
diff --git a/client/java/src/main/java/de/uni-bielefeld/cit-ec/opensource/hlrc/client/Tuple.java b/client/java/src/main/java/de/uni-bielefeld/cit-ec/opensource/hlrc/client/Tuple.java
index 67089a9..c60c72d 100644
--- a/client/java/src/main/java/de/uni-bielefeld/cit-ec/opensource/hlrc/client/Tuple.java
+++ b/client/java/src/main/java/de/uni-bielefeld/cit-ec/opensource/hlrc/client/Tuple.java
@@ -26,7 +26,7 @@
 *
 */
 
-package de.uni-bielefeld.cit-ec.opensource.hlrc.client;
+package de.uni_bielefeld.cit_ec.opensource.hlrc.client;
 
 /**
  *
diff --git a/client/java/src/main/java/de/uni-bielefeld/cit-ec/opensource/hlrc/examples/SimpleExample.java b/client/java/src/main/java/de/uni-bielefeld/cit-ec/opensource/hlrc/examples/SimpleExample.java
index 83ef90a..eef6cf7 100644
--- a/client/java/src/main/java/de/uni-bielefeld/cit-ec/opensource/hlrc/examples/SimpleExample.java
+++ b/client/java/src/main/java/de/uni-bielefeld/cit-ec/opensource/hlrc/examples/SimpleExample.java
@@ -26,10 +26,10 @@
 *
 */
 
-package de.uni-bielefeld.cit-ec.opensource.hlrc.examples;
+package de.uni_bielefeld.cit_ec.opensource.hlrc.examples;
 
-import de.uni-bielefeld.cit-ec.opensource.hlrc.client.Emotions;
-import de.uni-bielefeld.cit-ec.opensource.hlrc.client.RobotController;
+import de.uni_bielefeld.cit_ec.opensource.hlrc.client.Emotions;
+import de.uni_bielefeld.cit_ec.opensource.hlrc.client.RobotController;
 
 public class SimpleExample {
     
diff --git a/client/java/src/main/java/de/uni-bielefeld/cit-ec/opensource/hlrc/main/Cmd.java b/client/java/src/main/java/de/uni-bielefeld/cit-ec/opensource/hlrc/main/Cmd.java
index 8ec1b1c..226d17b 100644
--- a/client/java/src/main/java/de/uni-bielefeld/cit-ec/opensource/hlrc/main/Cmd.java
+++ b/client/java/src/main/java/de/uni-bielefeld/cit-ec/opensource/hlrc/main/Cmd.java
@@ -26,11 +26,11 @@
 *
 */
 
-package de.uni-bielefeld.cit-ec.opensource.hlrc.main;
+package de.uni_bielefeld.cit_ec.opensource.hlrc.main;
 
-import de.uni-bielefeld.cit-ec.opensource.hlrc.client.HeadAnimations;
-import de.uni-bielefeld.cit-ec.opensource.hlrc.client.Emotions;
-import de.uni-bielefeld.cit-ec.opensource.hlrc.client.RobotController;
+import de.uni_bielefeld.cit_ec.opensource.hlrc.client.HeadAnimations;
+import de.uni_bielefeld.cit_ec.opensource.hlrc.client.Emotions;
+import de.uni_bielefeld.cit_ec.opensource.hlrc.client.RobotController;
 
 import java.util.logging.Level;
 import java.util.logging.Logger;
@@ -91,7 +91,7 @@ public class Cmd {
             }
             
             if (line.getOptionValue("robotname") != null) {
-                robot = new Robot(line.getOptionValue("robotname"), "RSB");
+                robot = new RobotController(line.getOptionValue("robotname"), "RSB");
             } else {
                 System.out.println("--> You need to provide a robot name, see --help");
                 return;
diff --git a/client/java/src/test/java/HlrcClientTests.java b/client/java/src/test/java/HlrcClientTests.java
index f5a8991..5d400b2 100644
--- a/client/java/src/test/java/HlrcClientTests.java
+++ b/client/java/src/test/java/HlrcClientTests.java
@@ -26,9 +26,9 @@
 *
 */
 
-import de.uni-bielefeld.cit-ec.opensource.hlrc.client.HeadAnimations;
-import de.uni-bielefeld.cit-ec.opensource.hlrc.client.Emotions;
-import de.uni-bielefeld.cit-ec.opensource.hlrc.client.RobotController;
+import de.uni_bielefeld.cit_ec.opensource.hlrc.client.HeadAnimations;
+import de.uni_bielefeld.cit_ec.opensource.hlrc.client.Emotions;
+import de.uni_bielefeld.cit_ec.opensource.hlrc.client.RobotController;
 
 import org.junit.After;
 import org.junit.AfterClass;
@@ -62,7 +62,7 @@ public class HlrcClientTests {
     
     @Before
     public void setUp() {
-        this.r = new Robot("/home/kitchen/flobi", "RSB");
+        this.r = new RobotController("/home/kitchen/flobi", "RSB");
         System.out.println("* HLRC CLIENT TESTS: @Before method");
     }
     
@@ -75,7 +75,7 @@ public class HlrcClientTests {
     public void testConstructor() {
         System.out.println("Constructor");
         
-        assertEquals("TestRobot", this.r.getRobotName());
+        assertEquals("TestRobot", this.r.getRobotControllerName());
         assertEquals("RSB", r.getMiddleware());
     }
     
@@ -94,7 +94,7 @@ public class HlrcClientTests {
     @Test
     public void testEmotionCreation() {
         System.out.println("Emotion Message");
-        this.r.mw.createEmotionMessage(Emotions.SAD, 1000);
+        this.r.mw.createCurrentEmotionMessage(Emotions.SAD, 1000);
     }
     
 }